local anim8 = require 'anim8'


-- scr = {w = lg.getWidth(), h = lg.getHeight()}

local w, h = lg.getDimensions()
scr = {w = w, h = h,t="full"}

hx = scr.w/2 - scr.w/5
hy = scr.h/3

fonts = {
default = lg.newFont("/fonts/OpenSans-Regular.ttf", 20),
title = lg.newFont("/fonts/OpenSans-Regular.ttf", 45),
infos = lg.newFont("/fonts/OpenSans-Regular.ttf", 16),
battle = lg.newFont("/fonts/OpenSans-Regular.ttf", 25)
}

-- INIT FUNCTIONS


function loadgraphics()
	lg.setFont(fonts.infos)	
	lg.setBackgroundColor(0,0,0)		
	
	mouse.img = lg.newImage("assets/ms2.png")
	lg.setDefaultFilter('nearest', 'nearest', 0)		
	
	bg0.img = lg.newImage("assets/bg0.png")
	bg1.img = lg.newImage("assets/bg1.png")
	bg2.img = lg.newImage("assets/bg2.png")
	
	user.img = lg.newImage("assets/pawn.png")
	
	-- a_user.img = lg.newImage("assets/action.png")
	-- local g = anim8.newGrid(403, 338, a_user.img:getWidth(), a_user.img:getHeight())
	-- au_idle = anim8.newAnimation(g('1-1', 1), 0.06)
	-- au_1 = anim8.newAnimation(g('2-2', 1), 0.5)
	-- au_2 = anim8.newAnimation(g('3-3', 1), 0.5)
	-- au_3 = anim8.newAnimation(g('4-4', 1), 0.5)
	-- au_list={au_1,au_2,au_3,au_idle}
	

	
	lg.setDefaultFilter('nearest', 'nearest', 0)		
	
	--sound
	-- s_paper = love.audio.newSource("assets/paper.wav", "static")	
	
	-- music
	-- m_m1 = love.audio.newSource("assets/Jazz_Saxaphone.mp3", "static")	
		
	visor.img = lg.newImage("assets/1.png")
	visor.img:setFilter("nearest", "nearest", 0)
		
	init()
end

function u(t)	
	--animation update
	-- for i,au in ipairs(au_list) do
		-- au:update(t)
	-- end
	
	if act_timer == true then timer_ =  timer_ + 1*t end
	if act_timer == false then timer_ =  0 end
	
	if mouse.x and mouse.y then
		visor.a =  math.pi/2 + math.atan2(mouse.y - visor.y, mouse.x - visor.x)
	end
	
	-------------------
	
	--shoot1
	if #bullets1 > 0 then
		for i,v in ipairs(bullets1) do
			v.x = v.x + (v.dx * t)
			v.y = v.y + (v.dy * t)
			if v.x < 0 or v.x > gameWidth or v.y < 0 or v.y > gameHeight then
				table.remove(bullets1, i)
			end
		end
		if #bullets1 < 1 then user.shoot1 = false end
	end
	
	
	--load1
	if user.ls1act == true then
		if user.ls1 >= user.ls1m then
			user.ls1act = false
			user.ls1 = 0
			user.shoot1 = true
		else
			user.ls1 = user.ls1 + 1*t
		end
	end

	-------------------
	
	--shoot2
	if #bullets2 > 0 then
		for i,v in ipairs(bullets2) do
			v.x = v.x + (v.dx * t)
			v.y = v.y + (v.dy * t)
			if v.x < 0 or v.x > gameWidth or v.y < 0 or v.y > gameHeight then
				table.remove(bullets2, i)
			end
		end
		if #bullets2 < 1 then user.shoot2 = false end
	end
	
	
	--load2
	if user.ls2act == true then
		if user.ls2 >= user.ls2m then
			user.ls2act = false
			user.ls2 = 0
			user.shoot2 = true
		else
			user.ls2 = user.ls2 + 1*t
		end
	end
	
end

function draw()

lg.setColor(1,1,1,1)
lg.draw(bg1.img,bg1.x,bg1.y)

	if mouse.x and mouse.y then
		love.graphics.setColor(1,1,1,1)
		love.graphics.draw(visor.img, visor.x, visor.y, visor.a, visor.s, visor.s, visor.w/2, visor.h/2)
	end
	
	for i,v in ipairs(bullets1) do				
		love.graphics.setColor(1,1,1,1)
		love.graphics.circle("fill", v.x, v.y, v.r)	--debug
	end
	
	for i,v in ipairs(bullets2) do				
		love.graphics.setColor(1,1,1,1)
		love.graphics.circle("fill", v.x, v.y, v.r)	--debug
	end
		
	if init_var == "none" then
		init()
	end
	
	lg.print("BULLETS 1: "..tostring(#bullets1).." : "..tostring(user.ls1act).." - "..tostring(math.ceil(user.ls1)).." / "..tostring(user.ls1m), 10,10)
	lg.print("BULLETS 2: "..tostring(#bullets2).." : "..tostring(user.ls2act).." - "..tostring(math.ceil(user.ls2)).." / "..tostring(user.ls2m), 10,30)
end

function init()
	user.x_ = 460
	user.y_ = 107
end

function load_bullet(b)
	local startX = visor.x + (visor.w / 24)
	local startY = visor.y + (visor.h / 24)
	
	-- angle rotation
	local angle = math.atan2((mouse.y - startY), (mouse.x - startX))	
	local bulletDx = visor.speed*8 * math.cos(angle)
	local bulletDy = visor.speed*8 * math.sin(angle)
	
	--speed of bullet depend of speed visor.speed had to change that for better UX 
	--add dispersion factor	
	local size = 3.45
	table.insert(b, {x = startX, y = startY, dx = bulletDx, dy = bulletDy,r=size})	
	table.insert(b, {x = startX-15, y = startY+15, dx = bulletDx, dy = bulletDy,r=size})		
	table.insert(b, {x = startX-20, y = startY+20, dx = bulletDx, dy = bulletDy,r=size})		
	table.insert(b, {x = startX-25, y = startY-20, dx = bulletDx, dy = bulletDy,r=size})		
	table.insert(b, {x = startX-35, y = startY-30, dx = bulletDx, dy = bulletDy,r=size})
	table.insert(b, {x = startX-45, y = startY-40, dx = bulletDx, dy = bulletDy,r=size})
end

function endgame()	
end