lg = love.graphics

-- collision classic
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)	
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

-- collision rectangle
function CheckCollisionRect(rect1,rect2)	
  return rect1.x < rect2.x+rect2.w and
         rect2.x < rect1.x+rect1.w and
         rect1.y < rect2.y+rect2.h and
         rect2.y < rect1.y+rect1.h
end

-- collision circle (+ variable)
function CheckCollisionCircle(circleA, circleB,Vparam)
	if mouse.x and mouse.y then
    local dist = (circleA.x - circleB.x)^2 + (circleA.y - circleB.y)^2
    return dist <= (circleA.radius + circleB.radius+Vparam)^2
	end
end

-- end game
function exit_game()
	function love.keypressed(key)
	-- love.filesystem.write("user.sav", table.serialize(user,true,true))
		if key == "escape" and gs == 0 then			
			love.event.quit()
		end	
	end
end

function autosavestat()
	if love.filesystem.exists("user.sav") then
		-- Load
		user = loadstring(love.filesystem.read("user.sav"))()
	else
		-- Save
		love.filesystem.write("user.sav", table.serialize(user,true,true))
	end
end

-- progress bar
function pbar (x,y,h,w,va,vm,info,c1,c2,c3,tpb)
	-- va = variable active
	-- vm = variable max	
	wm = w
	wa = va / vm * wm	
	
	lg.setColor(c1,c2,c3,0.5)
	lg.rectangle("fill", x, y, wm, h)
	
	lg.setColor(c1,c2,c3,1)
	lg.rectangle("fill", x, y, wa, h)
	if tpb == "/" then 		
		lg.print(string.format(info), x,y-30)
		lg.print(string.format(math.ceil(va)).."/"..string.format(math.ceil(vm)), x+w/2,y-30)
	end
	if tpb == "%" then
		lg.print(string.format(info), x,y-30)
		lg.print(string.format(math.floor(va)).."%", x+w/2,y-30)
	end
end


-- progress tube
function ptubecd (x,y,h,w,va,vm,info,c1,c2,c3,tpb)
	-- va = variable active
	-- vm = variable max	
	hm = h
	ha = va / vm * hm	
	
	-- lg.setColor(c1,c2,c3,0.5)
	-- lg.rectangle("fill", x, y, w, -hm)
	
	lg.setColor(c1,c2,c3,1)
	lg.rectangle("fill", x, y, w, -ha)
	if tpb == "/" then 		
		lg.print(string.format(info), x,y-70)
		lg.print(string.format(math.ceil(va)).."/"..string.format(math.ceil(vm)), x+w/2,y-70)
	end
	if tpb == "%" then
		lg.print(string.format(info), x,y-70)
		lg.print(string.format(math.floor(va)).."%", x+w/2,y-70)
	end
end


-- progress tube
function ptube (x,y,h,w,va,vm,info,c1,c2,c3,tpb)
	-- va = variable active
	-- vm = variable max	
	hm = h
	ha = va / vm * hm	
	
	-- lg.setColor(c1,c2,c3,0.1)
	-- lg.rectangle("fill", x, y, w, hm)
	
	lg.setColor(c1,c2,c3,1)
	lg.rectangle("fill", x, y, w, ha)
	if tpb == "/" then 		
		lg.print(string.format(info), x,y-70)
		lg.print(string.format(math.ceil(va)).."/"..string.format(math.ceil(vm)), x+w/2,y-70)
	end
	if tpb == "%" then
		lg.print(string.format(info), x,y-70)
		lg.print(string.format(math.floor(va)).."%", x+w/2,y-70)
	end
end


-- SENOID
varsenoid = 0 
function senoid(func,amp, freq, offset)
    amp = amp/2
    if func == 'sin' then
        return amp*math.sin(freq*varsenoid) + offset + amp
    elseif func == 'cos' then
        return amp*math.cos(freq*varsenoid) + offset + amp
    end
end

-- TABLE EMPTY
function table.empty (self)
    for _, _ in pairs(self) do
        return false
    end
    return true
end

-- TABLE LENGHT
function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

-- UNIQUE RND
rng = love.math.newRandomGenerator()
-- rng:setSeed(os.time())
rng:setSeed(os.clock()*100000000000)

function shuffle(tbl)
  size = #tbl
  for i = size, 1, -1 do        
	local rand = rng:random(size)    
	tbl[i], tbl[rand] = tbl[rand], tbl[i]
  end
  return tbl
end

--FADE
function fadetimer(s,t)	
	if fade.act == true then
		if fade.t == "none" then fade.t = "in" end
		if fade.t == "in" and fade.a_in <= 1 then fade.a_in = fade.a_in + s*t end
		if fade.t == "in" and fade.a_in > 1 then fade.t = "out" end
		if fade.t == "out" and fade.a_out >= 0 then fade.a_out = fade.a_out - s*t end
		if fade.t == "out" and fade.a_out < 0 then fade.t = "none" fade.act = false fade.a_in = 0 fade.a_out = 1 end
	end	
end

function fadedraw(w,h)
	-- local w, h = lg.getDimensions()
	
	if fade.t == "out" then
		lg.setColor(0,0,0,fade.a_out)		
		lg.rectangle("fill", 0, 0, w, h)
	end
	if fade.t == "in" then
		lg.setColor(0,0,0,fade.a_in)		
		lg.rectangle("fill", 0, 0, w, h)
	end	
end
fade = {t = "none",a_out=1,a_in=0,act=false}

--add fadedraw() in draw
--add "fade.act = true" when needed

